      program p2p
      implicit none
c  FORTRAN MPI-INCLUDE-file
      include 'mpif.h'
      integer    ierr, nproc, myid
      integer    vec(100000000), rvec(100000000)
      integer    i, nl, ipto, ipfr, loop

c  initialize MPI, get nproc (# of procs) and myid (local proc. id)
      call MPI_INIT( ierr )
      call MPI_COMM_SIZE( MPI_COMM_WORLD, nproc, ierr )
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )

      do loop = 1 , 8
         nl = 10**loop
         do i = 1 , nl
            vec(i) =  myid 
         end do
         write(6,10)myid,nl,vec(1)
 10      format(i3,'>> size ',i10,' start value  ',i2)    
         ipfr = modulo(myid-1,nproc)
         ipto = modulo(myid+1,nproc)
         call MPI_SEND( vec, nl, MPI_INTEGER, ipto, 0,  
     :                     MPI_COMM_WORLD, ierr )
         call MPI_RECV( rvec, nl, MPI_INTEGER, ipfr, 0,  
     :                     MPI_COMM_WORLD, MPI_STATUS_IGNORE, ierr )
         write(6,11)myid,nl,rvec(1)
 11      format(i3,'>> size ',i10,' value after ring shift  ',i2)
      end do
      call MPI_FINALIZE( ierr )

      stop
      end



 
