      subroutine initialisierung_2d ( com_2d, n1, n2, a )
      implicit none
      include 'mpif.h'
      integer             n1, n2, coords(2), dims(2)
      real*8              a(0:n1+1,0:n2+1)
      real*8              anfangswert, randwert
      parameter         ( anfangswert = 1.0,
     :                    randwert = 9.0 )
      integer             j, j1, j2
      integer             com_2d, com, nproc, myid, ierr
      logical             periods(2)
   
      periods=.false.
      com = MPI_COMM_WORLD
      call MPI_COMM_SIZE( com, nproc, ierr )
      call MPI_COMM_RANK( com, myid, ierr )
      call MPI_CART_GET(com_2d,2,dims,periods,coords,ierr)
c--------- Initialisierung    
      do j2 = 1 , n2 
         do j1 = 1 , n1
            a(j1,j2) = anfangswert 
         end do
      end do
      if (coords(1).eq.0) then
         do j2 = 0 , n2+1
            a(0,j2) = randwert
         end do
      end if
      if (coords(1).eq.dims(1)-1) then
         do j2 = 0 , n2+1
            a(n1+1,j2) = randwert
         end do
      end if
      if (coords(2).eq.0) then
         do j1 = 0 , n1+1
            a(j1,0) = randwert 
         end do
      end if
      if (coords(2).eq.dims(2)-1) then
         do j1 = 0 , n1+1
            a(j1,n2+1) = randwert
         end do
      end if
      return
      end
