      subroutine randaustausch ( com_2d, n1, n2, a )
      implicit none
      include 'mpif.h'
      integer            com_2d, n1, n2
      real*8             a(0:n1+1,0:n2+1), as(1000), ar(1000)
      integer            i, ipu, ipd, ipl, ipr, com, nproc, myid, ierr, 
     :                   istat(MPI_STATUS_SIZE)
   
      com = MPI_COMM_WORLD
      call MPI_COMM_SIZE( com, nproc, ierr )
      call MPI_COMM_RANK( com, myid, ierr )
!  exchange of vertical boundaries 
      call MPI_CART_SHIFT(com_2d,1,1,ipl,ipr,ierr)
      call MPI_SENDRECV(a(1,1), n1, MPI_DOUBLE_PRECISION, ipl, 0,
     :                  a(1,0), n1, MPI_DOUBLE_PRECISION, ipl, 0, 
     :                  com, istat, ierr)
      call MPI_SENDRECV(a(1,n2), n1, MPI_DOUBLE_PRECISION, ipr, 0,
     :                  a(1,n2+1), n1, MPI_DOUBLE_PRECISION, ipr, 0, 
     :                  com, istat, ierr)

!  exchange of horizontal boundaries
      call MPI_CART_SHIFT(com_2d,0,1,ipu,ipd,ierr)
      as(1:n2) = a(1,1:n2)
      call MPI_SENDRECV(as, n2, MPI_DOUBLE_PRECISION, ipu, 0,
     :                  ar, n2, MPI_DOUBLE_PRECISION, ipu, 0,
     :                  com, istat, ierr)
      if (ipu.ge.0) then
         a(0,1:n2) = ar(1:n2)
      end if
      as(1:n2) = a(n1,1:n2)
      call MPI_SENDRECV(as, n2, MPI_DOUBLE_PRECISION, ipd, 0,
     :                  ar, n2, MPI_DOUBLE_PRECISION, ipd, 0,
     :                  com, istat, ierr)
      if (ipd.ge.0) then
         a(n1+1,1:n2) = ar(1:n2)
      end if
      return
      end
