      subroutine randaustausch ( com_2d, n1, n2, a )
      implicit none
      include 'mpif.h'
      integer            com_2d, n1, n2
      real*8             a(0:n1+1,0:n2+1)
      integer            i, ipu, ipd, ipl, ipr, com, nproc, myid, ierr, 
     :                   istat(MPI_STATUS_SIZE),row
   
      com = MPI_COMM_WORLD
      call MPI_COMM_SIZE( com, nproc, ierr )
      call MPI_COMM_RANK( com, myid, ierr )
!  exchange of vertical boundaries
      call MPI_CART_SHIFT(com_2d,1,1,ipl,ipr,ierr)
!      write(6,*)'vert. bdr. ',myid,ipl,ipr 
      call MPI_SENDRECV(a(1,1), n1, MPI_DOUBLE_PRECISION, ipl, 0,
     :                  a(1,0), n1, MPI_DOUBLE_PRECISION, ipl, 0, 
     :                  com, istat, ierr)
      call MPI_SENDRECV(a(1,n2), n1, MPI_DOUBLE_PRECISION, ipr, 0,
     :                  a(1,n2+1), n1, MPI_DOUBLE_PRECISION, ipr, 0, 
     :                  com, istat, ierr)

!  exchange of horizontal boundaries
      call MPI_CART_SHIFT(com_2d,0,1,ipu,ipd,ierr)
!      write(6,*)'horz. bdr. ',myid,ipu,ipd 
      call MPI_TYPE_VECTOR(n2, 1,  n1+2, MPI_DOUBLE_PRECISION,
     :                           row, ierr)
      call MPI_TYPE_COMMIT(row,ierr)
      call MPI_SENDRECV(a(1,1), 1, row, ipu, 0,
     :                  a(0,1), 1, row, ipu, 0,
     :                  com, istat, ierr)
      call MPI_SENDRECV(a(n1,1), 1, row, ipd, 0,
     :                  a(n1+1,1), 1, row, ipd, 0,
     :                  com, istat, ierr)
      call MPI_Type_free(row,ierr)
      return
      end
