      subroutine initialisierung ( n1, n2, a )
      implicit none
      include 'mpif.h'
      integer             n1, n2
      real*8              a(0:n1+1,0:n2+1)
      real*8              anfangswert, randwert
      parameter         ( anfangswert = 1.0,
     :                    randwert = 9.0 )
      integer             j, j1, j2
      integer             com, nproc, myid, ierr
   
      com = MPI_COMM_WORLD
      call MPI_COMM_SIZE( com, nproc, ierr )
      call MPI_COMM_RANK( com, myid, ierr )

c--------- Initialisierung    
      do j2 = 1 , n2 
         do j1 = 1 , n1
            a(j1,j2) = anfangswert
         end do
      end do
      if (myid.eq.0) then
         do j1 = 0 , n1+1
            a(j1,0) = randwert
         end do
      end if
      if (myid.eq.nproc-1) then
         do j1 = 0 , n1+1
            a(j1,n2+1) = randwert
         end do
      end if
      do j2 = 0 , n2+1
         a(0,j2) = randwert
         a(n1+1,j2) = randwert
      end do
 
      return
      end
