      subroutine timestep ( r, n1, n2, a, u, j2a, j2e )
      implicit none
      integer            n1, n2, j2a, j2e
      real*8             a(0:n1+1,0:n2+1), u(0:n1+1,0:n2+1)
      real*8             r
      integer            j1, j2
      real*8             s

      s = 1. - 4.*r

      do j2 = j2a , j2e 
         do j1 = 1 , n1 
            u(j1,j2) = s*  a(j1,j2) + r * (
     :                              a(j1-1,j2) +
     :           a(j1,j2-1)  +                       a(j1,j2+1) +
     :                              a(j1+1,j2)
     :                                                        )
         end do
      end do 

      return
      end
