      program piapp
      implicit none

      double precision pia, piexact
      integer  i, n
      double precision numint

      piexact = 3.14159265358979323846264338327950288419d0 

!  input of n
      write(6,*)'number of strips ?  '       
      read(5,*) n
      write(6,1001) n
 1001 format(//'calculation of pi using numerical integration of '
     :         'SQRT(1-x**2)'
     :        /'number of strips    : ',i20)

!  numerical approximation
      pia = numint(0.d0,1.d0/n,n,0.0)

!  output of results
      write(6,1111)piexact, pia, abs(pia-piexact)
 1111 format(/'pi exact              = ',f20.14,
     :       /'pi estimated          = ',f20.14,
     :       /'error                 = ',e20.3)

      stop
      end
