      program test_2dim
      implicit none
      include 'mpif.h'  
      integer com, com_2d, nproc, myid, ierr
      integer dims(2), np1, np2, myid_2d(2)
      logical periods(2), reorder
      com = MPI_COMM_WORLD
      call MPI_INIT( ierr )
      call MPI_COMM_SIZE( com, nproc, ierr )
      call MPI_COMM_RANK( com, myid, ierr )
      if (myid.eq.0) then
         read(5,*) np1, np2
      end if
      call MPI_BCAST( np1, 1, MPI_INTEGER, 0, com, ierr)
      call MPI_BCAST( np2, 1, MPI_INTEGER, 0, com, ierr)

      if (np1*np2.ne.nproc) then
         write(6,*)np1,np2,nproc,np1*np2
         call MPI_FINALIZE( ierr )
         stop
      end if
      dims(1) = np1 ; dims(2)= np2; periods = .false.  
      call MPI_CART_CREATE(com,2,dims,periods,.true.,com_2d,ierr)
      call MPI_CART_GET(com_2d,2,dims,periods,myid_2d,ierr)
      write(6,*)myid,myid_2d(1),myid_2d(2)
      call MPI_FINALIZE( ierr )
      stop
      end

